Difference between revisions of "Nintendo WiiMote"

From LinuxMCE
Jump to: navigation, search
(cleanup, rewrote wminputd)
Line 26: Line 26:
  
 
create the daemon
 
create the daemon
  vi /usr/sbin/wminputd
+
  cat >/usr/sbin/wminputd <<"EOF"
 
+
 
  #!/bin/bash
 
  #!/bin/bash
 
  #read the config file
 
  #read the config file
Line 33: Line 32:
 
  export DISPLAY=:0
 
  export DISPLAY=:0
 
   
 
   
  while true ; do
+
  while true
         #check if the OrbiterGL is already running!
+
do
        LMCE=`pidof OrbiterGL`
+
         #check if the Orbiter/OrbiterGL is already running!
         if [ ! -z $LMCE ] ; then
+
         if [ "$(pidof OrbiterGL)$(pidof Orbiter)" ]
                while true ; do
+
        then
 +
 
                 #check if the wiimote is already connected
 
                 #check if the wiimote is already connected
                 SCAN=`hcitool con|grep $WIIMOTE_BDADDR`
+
                 if [ -z "$(hcitool con|grep $WIIMOTE_BDADDR)" ]
                        if [ -z $SCAN ] ; then
+
                then
                                PID=`pidof wminput`
+
                        PID=$(pidof wminput)
 +
                        if [ "$PID" ]
 +
                        then
 
                                 kill -9 $PID
 
                                 kill -9 $PID
                                xset m 3 1/2
 
                                wminput -c ir_ptr $WIIMOTE_BDADDR &
 
                                sleep 5
 
                        else
 
                                sleep 5
 
 
                         fi
 
                         fi
                 done
+
                        #mouse acceleration, adjust to your liking
        fi
+
                        #see also: "man xset" and/or "xset -h"
 +
#                      xset m 1/2 3
 +
                        wminput -c ir_ptr $WIIMOTE_BDADDR &
 +
                 fi
 +
 +
        fi
 +
 +
        sleep 5
 +
 
  done
 
  done
 +
 +
EOF
  
 
Make it executable
 
Make it executable
Line 60: Line 67:
  
 
  #this is the config file for the wminputd
 
  #this is the config file for the wminputd
  #enter the wiimote mac address, you can find it with ~#hcitool scan  and then press the red button
+
  #enter the wiimote mac address, you can find it with
 +
#hcitool scan  and then press the red button
 
  #besides the battery's off the wiimote
 
  #besides the battery's off the wiimote
 
  #Then place the show'n mac address as follows
 
  #Then place the show'n mac address as follows
Line 74: Line 82:
 
  #buttons
 
  #buttons
 
   
 
   
  Wiimote.A               = BTN_LEFT
+
  Wiimote.A       = BTN_LEFT
  Wiimote.B               = BTN_RIGHT
+
  Wiimote.B       = BTN_RIGHT
  Wiimote.Up             = KEY_UP
+
  Wiimote.Up     = KEY_UP
 
  Wiimote.Down    = KEY_DOWN
 
  Wiimote.Down    = KEY_DOWN
 
  Wiimote.Left    = KEY_LEFT
 
  Wiimote.Left    = KEY_LEFT
Line 83: Line 91:
 
  Wiimote.Plus    = KEY_F8
 
  Wiimote.Plus    = KEY_F8
 
  Wiimote.Home    = KEY_F3
 
  Wiimote.Home    = KEY_F3
  Wiimote.1               = KEY_F1
+
  Wiimote.1       = KEY_F1
  Wiimote.2               = KEY_F6
+
  Wiimote.2       = KEY_F6
  
  

Revision as of 22:18, 3 April 2008

Wiimote.jpg

This device is not out of the box supported by LinuxMCE, but it is known to work [1] [2] [3].

Wiimote setup

I will try to explain what i have done to make the wiimote work with linuxmce.

The wiimote is a cheap gyration device which could work for linuxmce instead of the chief remote from fiire which i find to expensive!!

Setup

Login as root to the media director which has a bluetooth stick with ssh. Install the cwiid driver as fllows

apt-get install libcwiid0
apt-get install wminput

Make sure the uinput kernel module is loaded at boot-time:

echo "uinput" >>/etc/modules

Load it manually in the mean time:

modprobe uinput

create the daemon

cat >/usr/sbin/wminputd <<"EOF"
#!/bin/bash
#read the config file
. /etc/wminputd.conf
export DISPLAY=:0

while true
do
        #check if the Orbiter/OrbiterGL is already running!
        if [ "$(pidof OrbiterGL)$(pidof Orbiter)" ]
        then

                #check if the wiimote is already connected
                if [ -z "$(hcitool con|grep $WIIMOTE_BDADDR)" ]
                then
                        PID=$(pidof wminput)
                        if [ "$PID" ]
                        then
                                kill -9 $PID
                        fi
                        #mouse acceleration, adjust to your liking
                        #see also: "man xset" and/or "xset -h"
#                       xset m 1/2 3
                        wminput -c ir_ptr $WIIMOTE_BDADDR &
                fi

       fi

       sleep 5

done

EOF

Make it executable

chmod 755 /usr/sbin/wminputd
  • Create the config file
vi /etc/wminputd.conf
#this is the config file for the wminputd
#enter the wiimote mac address, you can find it with
#hcitool scan  and then press the red button
#besides the battery's off the wiimote
#Then place the show'n mac address as follows
WIIMOTE_BDADDR="00:AA:00:BB:AA:FF"

you can find your address with hcitool scan

  • Edit the file /etc/cwiid/wminput/buttons
vi /etc/cwiid/wminput/buttons

And make it suitable to your needs below is mine

#buttons

Wiimote.A       = BTN_LEFT
Wiimote.B       = BTN_RIGHT
Wiimote.Up      = KEY_UP
Wiimote.Down    = KEY_DOWN
Wiimote.Left    = KEY_LEFT
Wiimote.Right   = KEY_RIGHT
Wiimote.Minus   = KEY_F7
Wiimote.Plus    = KEY_F8
Wiimote.Home    = KEY_F3
Wiimote.1       = KEY_F1
Wiimote.2       = KEY_F6


  • create the init file
vi /etc/init.d/wminputd
#!/bin/sh
# Start/stop the wminputd daemon.
#
### BEGIN INIT INFO
# Provides:          wminputd
# Required-Start:    $syslog $time
# Required-Stop:     $syslog $time
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: mousemodule
# Description:       wminputd
#
#
#
### END INIT INFO


test -f /usr/sbin/wminputd || exit 0
. /lib/lsb/init-functions

case "$1" in
start)  log_daemon_msg "Starting wii-remote mousemodule" "wminputd"
        start-stop-daemon -b --start --quiet --pidfile /var/run/wminputd.pid --name wminputd --startas /usr/sbin/wminputd -- $LSBNAMES
        log_end_msg $?
        ;;
stop)   log_daemon_msg "Stopping wii-mote mousemodule" "wminputd"
        start-stop-daemon --stop --quiet --pidfile /var/run/wminputd.pid --name wminputd
        log_end_msg $?
        ;;
restart) log_daemon_msg "Restarting wii-mote mousemdule" "wminputd"
        start-stop-daemon --stop --retry 5 --quiet --pidfile /var/run/wminputd.pid --name wminputd
        start-stop-daemon -b --start --quiet --pidfile /var/run/wminputd.pid --name wminputd --startas /usr/sbin/wminputd -- $LSBNAMES
        log_end_msg $?
        ;;
*)      log_action_msg "Usage: /etc/init.d/wminputd {start|stop|restart}"
        exit 2
        ;;
esac
exit 0

Make it executable

chmod 755 /etc/init.d/wminputd

run the script and push the red button beside the battery and your wiimote is ready to go

enable the script so it wil start at boot time

update-rc.d wminputd defaults

now start the script and take look if it works

/etc/init.d/wminputd start

Troubleshooting

  • Q: When i reload the router then the wiimote will be slow
  • A: Just push the red button besides the wiimote so it will connect again


Added 3-30-2008

I tried this and it works beautifully!

A couple of other notes...

Its a pain to get to the little red button by the battery. Instead, you can press and hold the '1' and '2' buttons at the same time for the same effect. The power button will not start the system, but once the system is started (with either the Red button or the button 1+2 being held down together), holding the power button for a couple of seconds will turn the wiimote off and break the connection.